<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAgencyCard ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAgencyCard
 * @subpackage Arrays
 */
class ArrayOfAgencyCard extends AbstractStructArrayBase
{
    /**
     * The AgencyCard
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AgencyCard[]
     */
    public $AgencyCard;
    /**
     * Constructor method for ArrayOfAgencyCard
     * @uses ArrayOfAgencyCard::setAgencyCard()
     * @param \StructType\AgencyCard[] $agencyCard
     */
    public function __construct(array $agencyCard = array())
    {
        $this
            ->setAgencyCard($agencyCard);
    }
    /**
     * Get AgencyCard value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AgencyCard[]|null
     */
    public function getAgencyCard()
    {
        return isset($this->AgencyCard) ? $this->AgencyCard : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAgencyCard method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAgencyCard method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAgencyCardForArrayConstraintsFromSetAgencyCard(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAgencyCardAgencyCardItem) {
            // validation for constraint: itemType
            if (!$arrayOfAgencyCardAgencyCardItem instanceof \StructType\AgencyCard) {
                $invalidValues[] = is_object($arrayOfAgencyCardAgencyCardItem) ? get_class($arrayOfAgencyCardAgencyCardItem) : sprintf('%s(%s)', gettype($arrayOfAgencyCardAgencyCardItem), var_export($arrayOfAgencyCardAgencyCardItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AgencyCard property can only contain items of type \StructType\AgencyCard, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AgencyCard value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AgencyCard[] $agencyCard
     * @return \ArrayType\ArrayOfAgencyCard
     */
    public function setAgencyCard(array $agencyCard = array())
    {
        // validation for constraint: array
        if ('' !== ($agencyCardArrayErrorMessage = self::validateAgencyCardForArrayConstraintsFromSetAgencyCard($agencyCard))) {
            throw new \InvalidArgumentException($agencyCardArrayErrorMessage, __LINE__);
        }
        if (is_null($agencyCard) || (is_array($agencyCard) && empty($agencyCard))) {
            unset($this->AgencyCard);
        } else {
            $this->AgencyCard = $agencyCard;
        }
        return $this;
    }
    /**
     * Add item to AgencyCard value
     * @throws \InvalidArgumentException
     * @param \StructType\AgencyCard $item
     * @return \ArrayType\ArrayOfAgencyCard
     */
    public function addToAgencyCard(\StructType\AgencyCard $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AgencyCard) {
            throw new \InvalidArgumentException(sprintf('The AgencyCard property can only contain items of type \StructType\AgencyCard, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AgencyCard[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AgencyCard|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AgencyCard|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AgencyCard|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AgencyCard|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AgencyCard|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AgencyCard
     */
    public function getAttributeName()
    {
        return 'AgencyCard';
    }
}
