<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirAirlineCarrier ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirAirlineCarrier
 * @subpackage Arrays
 */
class ArrayOfAirAirlineCarrier extends AbstractStructArrayBase
{
    /**
     * The AirAirlineCarrier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirAirlineCarrier[]
     */
    public $AirAirlineCarrier;
    /**
     * Constructor method for ArrayOfAirAirlineCarrier
     * @uses ArrayOfAirAirlineCarrier::setAirAirlineCarrier()
     * @param \StructType\AirAirlineCarrier[] $airAirlineCarrier
     */
    public function __construct(array $airAirlineCarrier = array())
    {
        $this
            ->setAirAirlineCarrier($airAirlineCarrier);
    }
    /**
     * Get AirAirlineCarrier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirAirlineCarrier[]|null
     */
    public function getAirAirlineCarrier()
    {
        return isset($this->AirAirlineCarrier) ? $this->AirAirlineCarrier : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirAirlineCarrier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirAirlineCarrier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirAirlineCarrierForArrayConstraintsFromSetAirAirlineCarrier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirAirlineCarrierAirAirlineCarrierItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirAirlineCarrierAirAirlineCarrierItem instanceof \StructType\AirAirlineCarrier) {
                $invalidValues[] = is_object($arrayOfAirAirlineCarrierAirAirlineCarrierItem) ? get_class($arrayOfAirAirlineCarrierAirAirlineCarrierItem) : sprintf('%s(%s)', gettype($arrayOfAirAirlineCarrierAirAirlineCarrierItem), var_export($arrayOfAirAirlineCarrierAirAirlineCarrierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirAirlineCarrier property can only contain items of type \StructType\AirAirlineCarrier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirAirlineCarrier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirAirlineCarrier[] $airAirlineCarrier
     * @return \ArrayType\ArrayOfAirAirlineCarrier
     */
    public function setAirAirlineCarrier(array $airAirlineCarrier = array())
    {
        // validation for constraint: array
        if ('' !== ($airAirlineCarrierArrayErrorMessage = self::validateAirAirlineCarrierForArrayConstraintsFromSetAirAirlineCarrier($airAirlineCarrier))) {
            throw new \InvalidArgumentException($airAirlineCarrierArrayErrorMessage, __LINE__);
        }
        if (is_null($airAirlineCarrier) || (is_array($airAirlineCarrier) && empty($airAirlineCarrier))) {
            unset($this->AirAirlineCarrier);
        } else {
            $this->AirAirlineCarrier = $airAirlineCarrier;
        }
        return $this;
    }
    /**
     * Add item to AirAirlineCarrier value
     * @throws \InvalidArgumentException
     * @param \StructType\AirAirlineCarrier $item
     * @return \ArrayType\ArrayOfAirAirlineCarrier
     */
    public function addToAirAirlineCarrier(\StructType\AirAirlineCarrier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirAirlineCarrier) {
            throw new \InvalidArgumentException(sprintf('The AirAirlineCarrier property can only contain items of type \StructType\AirAirlineCarrier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirAirlineCarrier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirAirlineCarrier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirAirlineCarrier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirAirlineCarrier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirAirlineCarrier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirAirlineCarrier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirAirlineCarrier
     */
    public function getAttributeName()
    {
        return 'AirAirlineCarrier';
    }
}
