<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirBookingBaggageNDC ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirBookingBaggageNDC
 * @subpackage Arrays
 */
class ArrayOfAirBookingBaggageNDC extends AbstractStructArrayBase
{
    /**
     * The AirBookingBaggageNDC
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirBookingBaggageNDC[]
     */
    public $AirBookingBaggageNDC;
    /**
     * Constructor method for ArrayOfAirBookingBaggageNDC
     * @uses ArrayOfAirBookingBaggageNDC::setAirBookingBaggageNDC()
     * @param \StructType\AirBookingBaggageNDC[] $airBookingBaggageNDC
     */
    public function __construct(array $airBookingBaggageNDC = array())
    {
        $this
            ->setAirBookingBaggageNDC($airBookingBaggageNDC);
    }
    /**
     * Get AirBookingBaggageNDC value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirBookingBaggageNDC[]|null
     */
    public function getAirBookingBaggageNDC()
    {
        return isset($this->AirBookingBaggageNDC) ? $this->AirBookingBaggageNDC : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirBookingBaggageNDC method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirBookingBaggageNDC method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirBookingBaggageNDCForArrayConstraintsFromSetAirBookingBaggageNDC(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirBookingBaggageNDCAirBookingBaggageNDCItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirBookingBaggageNDCAirBookingBaggageNDCItem instanceof \StructType\AirBookingBaggageNDC) {
                $invalidValues[] = is_object($arrayOfAirBookingBaggageNDCAirBookingBaggageNDCItem) ? get_class($arrayOfAirBookingBaggageNDCAirBookingBaggageNDCItem) : sprintf('%s(%s)', gettype($arrayOfAirBookingBaggageNDCAirBookingBaggageNDCItem), var_export($arrayOfAirBookingBaggageNDCAirBookingBaggageNDCItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirBookingBaggageNDC property can only contain items of type \StructType\AirBookingBaggageNDC, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirBookingBaggageNDC value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingBaggageNDC[] $airBookingBaggageNDC
     * @return \ArrayType\ArrayOfAirBookingBaggageNDC
     */
    public function setAirBookingBaggageNDC(array $airBookingBaggageNDC = array())
    {
        // validation for constraint: array
        if ('' !== ($airBookingBaggageNDCArrayErrorMessage = self::validateAirBookingBaggageNDCForArrayConstraintsFromSetAirBookingBaggageNDC($airBookingBaggageNDC))) {
            throw new \InvalidArgumentException($airBookingBaggageNDCArrayErrorMessage, __LINE__);
        }
        if (is_null($airBookingBaggageNDC) || (is_array($airBookingBaggageNDC) && empty($airBookingBaggageNDC))) {
            unset($this->AirBookingBaggageNDC);
        } else {
            $this->AirBookingBaggageNDC = $airBookingBaggageNDC;
        }
        return $this;
    }
    /**
     * Add item to AirBookingBaggageNDC value
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingBaggageNDC $item
     * @return \ArrayType\ArrayOfAirBookingBaggageNDC
     */
    public function addToAirBookingBaggageNDC(\StructType\AirBookingBaggageNDC $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirBookingBaggageNDC) {
            throw new \InvalidArgumentException(sprintf('The AirBookingBaggageNDC property can only contain items of type \StructType\AirBookingBaggageNDC, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirBookingBaggageNDC[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirBookingBaggageNDC|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirBookingBaggageNDC|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirBookingBaggageNDC|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirBookingBaggageNDC|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirBookingBaggageNDC|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirBookingBaggageNDC
     */
    public function getAttributeName()
    {
        return 'AirBookingBaggageNDC';
    }
}
