<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirBookingFare ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirBookingFare
 * @subpackage Arrays
 */
class ArrayOfAirBookingFare extends AbstractStructArrayBase
{
    /**
     * The AirBookingFare
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirBookingFare[]
     */
    public $AirBookingFare;
    /**
     * Constructor method for ArrayOfAirBookingFare
     * @uses ArrayOfAirBookingFare::setAirBookingFare()
     * @param \StructType\AirBookingFare[] $airBookingFare
     */
    public function __construct(array $airBookingFare = array())
    {
        $this
            ->setAirBookingFare($airBookingFare);
    }
    /**
     * Get AirBookingFare value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirBookingFare[]|null
     */
    public function getAirBookingFare()
    {
        return isset($this->AirBookingFare) ? $this->AirBookingFare : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirBookingFare method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirBookingFare method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirBookingFareForArrayConstraintsFromSetAirBookingFare(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirBookingFareAirBookingFareItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirBookingFareAirBookingFareItem instanceof \StructType\AirBookingFare) {
                $invalidValues[] = is_object($arrayOfAirBookingFareAirBookingFareItem) ? get_class($arrayOfAirBookingFareAirBookingFareItem) : sprintf('%s(%s)', gettype($arrayOfAirBookingFareAirBookingFareItem), var_export($arrayOfAirBookingFareAirBookingFareItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirBookingFare property can only contain items of type \StructType\AirBookingFare, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirBookingFare value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingFare[] $airBookingFare
     * @return \ArrayType\ArrayOfAirBookingFare
     */
    public function setAirBookingFare(array $airBookingFare = array())
    {
        // validation for constraint: array
        if ('' !== ($airBookingFareArrayErrorMessage = self::validateAirBookingFareForArrayConstraintsFromSetAirBookingFare($airBookingFare))) {
            throw new \InvalidArgumentException($airBookingFareArrayErrorMessage, __LINE__);
        }
        if (is_null($airBookingFare) || (is_array($airBookingFare) && empty($airBookingFare))) {
            unset($this->AirBookingFare);
        } else {
            $this->AirBookingFare = $airBookingFare;
        }
        return $this;
    }
    /**
     * Add item to AirBookingFare value
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingFare $item
     * @return \ArrayType\ArrayOfAirBookingFare
     */
    public function addToAirBookingFare(\StructType\AirBookingFare $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirBookingFare) {
            throw new \InvalidArgumentException(sprintf('The AirBookingFare property can only contain items of type \StructType\AirBookingFare, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirBookingFare[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirBookingFare|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirBookingFare|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirBookingFare|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirBookingFare|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirBookingFare|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirBookingFare
     */
    public function getAttributeName()
    {
        return 'AirBookingFare';
    }
}
