<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirBookingFareFamilies ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirBookingFareFamilies
 * @subpackage Arrays
 */
class ArrayOfAirBookingFareFamilies extends AbstractStructArrayBase
{
    /**
     * The AirBookingFareFamilies
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirBookingFareFamilies[]
     */
    public $AirBookingFareFamilies;
    /**
     * Constructor method for ArrayOfAirBookingFareFamilies
     * @uses ArrayOfAirBookingFareFamilies::setAirBookingFareFamilies()
     * @param \StructType\AirBookingFareFamilies[] $airBookingFareFamilies
     */
    public function __construct(array $airBookingFareFamilies = array())
    {
        $this
            ->setAirBookingFareFamilies($airBookingFareFamilies);
    }
    /**
     * Get AirBookingFareFamilies value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirBookingFareFamilies[]|null
     */
    public function getAirBookingFareFamilies()
    {
        return isset($this->AirBookingFareFamilies) ? $this->AirBookingFareFamilies : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirBookingFareFamilies method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirBookingFareFamilies method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirBookingFareFamiliesForArrayConstraintsFromSetAirBookingFareFamilies(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirBookingFareFamiliesAirBookingFareFamiliesItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirBookingFareFamiliesAirBookingFareFamiliesItem instanceof \StructType\AirBookingFareFamilies) {
                $invalidValues[] = is_object($arrayOfAirBookingFareFamiliesAirBookingFareFamiliesItem) ? get_class($arrayOfAirBookingFareFamiliesAirBookingFareFamiliesItem) : sprintf('%s(%s)', gettype($arrayOfAirBookingFareFamiliesAirBookingFareFamiliesItem), var_export($arrayOfAirBookingFareFamiliesAirBookingFareFamiliesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirBookingFareFamilies property can only contain items of type \StructType\AirBookingFareFamilies, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirBookingFareFamilies value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingFareFamilies[] $airBookingFareFamilies
     * @return \ArrayType\ArrayOfAirBookingFareFamilies
     */
    public function setAirBookingFareFamilies(array $airBookingFareFamilies = array())
    {
        // validation for constraint: array
        if ('' !== ($airBookingFareFamiliesArrayErrorMessage = self::validateAirBookingFareFamiliesForArrayConstraintsFromSetAirBookingFareFamilies($airBookingFareFamilies))) {
            throw new \InvalidArgumentException($airBookingFareFamiliesArrayErrorMessage, __LINE__);
        }
        if (is_null($airBookingFareFamilies) || (is_array($airBookingFareFamilies) && empty($airBookingFareFamilies))) {
            unset($this->AirBookingFareFamilies);
        } else {
            $this->AirBookingFareFamilies = $airBookingFareFamilies;
        }
        return $this;
    }
    /**
     * Add item to AirBookingFareFamilies value
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingFareFamilies $item
     * @return \ArrayType\ArrayOfAirBookingFareFamilies
     */
    public function addToAirBookingFareFamilies(\StructType\AirBookingFareFamilies $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirBookingFareFamilies) {
            throw new \InvalidArgumentException(sprintf('The AirBookingFareFamilies property can only contain items of type \StructType\AirBookingFareFamilies, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirBookingFareFamilies[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirBookingFareFamilies|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirBookingFareFamilies|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirBookingFareFamilies|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirBookingFareFamilies|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirBookingFareFamilies|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirBookingFareFamilies
     */
    public function getAttributeName()
    {
        return 'AirBookingFareFamilies';
    }
}
