<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirBookingFlightSegment ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirBookingFlightSegment
 * @subpackage Arrays
 */
class ArrayOfAirBookingFlightSegment extends AbstractStructArrayBase
{
    /**
     * The AirBookingFlightSegment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirBookingFlightSegment[]
     */
    public $AirBookingFlightSegment;
    /**
     * Constructor method for ArrayOfAirBookingFlightSegment
     * @uses ArrayOfAirBookingFlightSegment::setAirBookingFlightSegment()
     * @param \StructType\AirBookingFlightSegment[] $airBookingFlightSegment
     */
    public function __construct(array $airBookingFlightSegment = array())
    {
        $this
            ->setAirBookingFlightSegment($airBookingFlightSegment);
    }
    /**
     * Get AirBookingFlightSegment value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirBookingFlightSegment[]|null
     */
    public function getAirBookingFlightSegment()
    {
        return isset($this->AirBookingFlightSegment) ? $this->AirBookingFlightSegment : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirBookingFlightSegment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirBookingFlightSegment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirBookingFlightSegmentForArrayConstraintsFromSetAirBookingFlightSegment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirBookingFlightSegmentAirBookingFlightSegmentItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirBookingFlightSegmentAirBookingFlightSegmentItem instanceof \StructType\AirBookingFlightSegment) {
                $invalidValues[] = is_object($arrayOfAirBookingFlightSegmentAirBookingFlightSegmentItem) ? get_class($arrayOfAirBookingFlightSegmentAirBookingFlightSegmentItem) : sprintf('%s(%s)', gettype($arrayOfAirBookingFlightSegmentAirBookingFlightSegmentItem), var_export($arrayOfAirBookingFlightSegmentAirBookingFlightSegmentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirBookingFlightSegment property can only contain items of type \StructType\AirBookingFlightSegment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirBookingFlightSegment value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingFlightSegment[] $airBookingFlightSegment
     * @return \ArrayType\ArrayOfAirBookingFlightSegment
     */
    public function setAirBookingFlightSegment(array $airBookingFlightSegment = array())
    {
        // validation for constraint: array
        if ('' !== ($airBookingFlightSegmentArrayErrorMessage = self::validateAirBookingFlightSegmentForArrayConstraintsFromSetAirBookingFlightSegment($airBookingFlightSegment))) {
            throw new \InvalidArgumentException($airBookingFlightSegmentArrayErrorMessage, __LINE__);
        }
        if (is_null($airBookingFlightSegment) || (is_array($airBookingFlightSegment) && empty($airBookingFlightSegment))) {
            unset($this->AirBookingFlightSegment);
        } else {
            $this->AirBookingFlightSegment = $airBookingFlightSegment;
        }
        return $this;
    }
    /**
     * Add item to AirBookingFlightSegment value
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingFlightSegment $item
     * @return \ArrayType\ArrayOfAirBookingFlightSegment
     */
    public function addToAirBookingFlightSegment(\StructType\AirBookingFlightSegment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirBookingFlightSegment) {
            throw new \InvalidArgumentException(sprintf('The AirBookingFlightSegment property can only contain items of type \StructType\AirBookingFlightSegment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirBookingFlightSegment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirBookingFlightSegment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirBookingFlightSegment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirBookingFlightSegment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirBookingFlightSegment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirBookingFlightSegment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirBookingFlightSegment
     */
    public function getAttributeName()
    {
        return 'AirBookingFlightSegment';
    }
}
