<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirBookingFlightSegmentLeg ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirBookingFlightSegmentLeg
 * @subpackage Arrays
 */
class ArrayOfAirBookingFlightSegmentLeg extends AbstractStructArrayBase
{
    /**
     * The AirBookingFlightSegmentLeg
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirBookingFlightSegmentLeg[]
     */
    public $AirBookingFlightSegmentLeg;
    /**
     * Constructor method for ArrayOfAirBookingFlightSegmentLeg
     * @uses ArrayOfAirBookingFlightSegmentLeg::setAirBookingFlightSegmentLeg()
     * @param \StructType\AirBookingFlightSegmentLeg[] $airBookingFlightSegmentLeg
     */
    public function __construct(array $airBookingFlightSegmentLeg = array())
    {
        $this
            ->setAirBookingFlightSegmentLeg($airBookingFlightSegmentLeg);
    }
    /**
     * Get AirBookingFlightSegmentLeg value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirBookingFlightSegmentLeg[]|null
     */
    public function getAirBookingFlightSegmentLeg()
    {
        return isset($this->AirBookingFlightSegmentLeg) ? $this->AirBookingFlightSegmentLeg : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirBookingFlightSegmentLeg method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirBookingFlightSegmentLeg method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirBookingFlightSegmentLegForArrayConstraintsFromSetAirBookingFlightSegmentLeg(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirBookingFlightSegmentLegAirBookingFlightSegmentLegItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirBookingFlightSegmentLegAirBookingFlightSegmentLegItem instanceof \StructType\AirBookingFlightSegmentLeg) {
                $invalidValues[] = is_object($arrayOfAirBookingFlightSegmentLegAirBookingFlightSegmentLegItem) ? get_class($arrayOfAirBookingFlightSegmentLegAirBookingFlightSegmentLegItem) : sprintf('%s(%s)', gettype($arrayOfAirBookingFlightSegmentLegAirBookingFlightSegmentLegItem), var_export($arrayOfAirBookingFlightSegmentLegAirBookingFlightSegmentLegItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirBookingFlightSegmentLeg property can only contain items of type \StructType\AirBookingFlightSegmentLeg, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirBookingFlightSegmentLeg value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingFlightSegmentLeg[] $airBookingFlightSegmentLeg
     * @return \ArrayType\ArrayOfAirBookingFlightSegmentLeg
     */
    public function setAirBookingFlightSegmentLeg(array $airBookingFlightSegmentLeg = array())
    {
        // validation for constraint: array
        if ('' !== ($airBookingFlightSegmentLegArrayErrorMessage = self::validateAirBookingFlightSegmentLegForArrayConstraintsFromSetAirBookingFlightSegmentLeg($airBookingFlightSegmentLeg))) {
            throw new \InvalidArgumentException($airBookingFlightSegmentLegArrayErrorMessage, __LINE__);
        }
        if (is_null($airBookingFlightSegmentLeg) || (is_array($airBookingFlightSegmentLeg) && empty($airBookingFlightSegmentLeg))) {
            unset($this->AirBookingFlightSegmentLeg);
        } else {
            $this->AirBookingFlightSegmentLeg = $airBookingFlightSegmentLeg;
        }
        return $this;
    }
    /**
     * Add item to AirBookingFlightSegmentLeg value
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingFlightSegmentLeg $item
     * @return \ArrayType\ArrayOfAirBookingFlightSegmentLeg
     */
    public function addToAirBookingFlightSegmentLeg(\StructType\AirBookingFlightSegmentLeg $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirBookingFlightSegmentLeg) {
            throw new \InvalidArgumentException(sprintf('The AirBookingFlightSegmentLeg property can only contain items of type \StructType\AirBookingFlightSegmentLeg, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirBookingFlightSegmentLeg[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirBookingFlightSegmentLeg|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirBookingFlightSegmentLeg|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirBookingFlightSegmentLeg|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirBookingFlightSegmentLeg|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirBookingFlightSegmentLeg|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirBookingFlightSegmentLeg
     */
    public function getAttributeName()
    {
        return 'AirBookingFlightSegmentLeg';
    }
}
