<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirBookingNote ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirBookingNote
 * @subpackage Arrays
 */
class ArrayOfAirBookingNote extends AbstractStructArrayBase
{
    /**
     * The AirBookingNote
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirBookingNote[]
     */
    public $AirBookingNote;
    /**
     * Constructor method for ArrayOfAirBookingNote
     * @uses ArrayOfAirBookingNote::setAirBookingNote()
     * @param \StructType\AirBookingNote[] $airBookingNote
     */
    public function __construct(array $airBookingNote = array())
    {
        $this
            ->setAirBookingNote($airBookingNote);
    }
    /**
     * Get AirBookingNote value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirBookingNote[]|null
     */
    public function getAirBookingNote()
    {
        return isset($this->AirBookingNote) ? $this->AirBookingNote : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirBookingNote method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirBookingNote method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirBookingNoteForArrayConstraintsFromSetAirBookingNote(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirBookingNoteAirBookingNoteItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirBookingNoteAirBookingNoteItem instanceof \StructType\AirBookingNote) {
                $invalidValues[] = is_object($arrayOfAirBookingNoteAirBookingNoteItem) ? get_class($arrayOfAirBookingNoteAirBookingNoteItem) : sprintf('%s(%s)', gettype($arrayOfAirBookingNoteAirBookingNoteItem), var_export($arrayOfAirBookingNoteAirBookingNoteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirBookingNote property can only contain items of type \StructType\AirBookingNote, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirBookingNote value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingNote[] $airBookingNote
     * @return \ArrayType\ArrayOfAirBookingNote
     */
    public function setAirBookingNote(array $airBookingNote = array())
    {
        // validation for constraint: array
        if ('' !== ($airBookingNoteArrayErrorMessage = self::validateAirBookingNoteForArrayConstraintsFromSetAirBookingNote($airBookingNote))) {
            throw new \InvalidArgumentException($airBookingNoteArrayErrorMessage, __LINE__);
        }
        if (is_null($airBookingNote) || (is_array($airBookingNote) && empty($airBookingNote))) {
            unset($this->AirBookingNote);
        } else {
            $this->AirBookingNote = $airBookingNote;
        }
        return $this;
    }
    /**
     * Add item to AirBookingNote value
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingNote $item
     * @return \ArrayType\ArrayOfAirBookingNote
     */
    public function addToAirBookingNote(\StructType\AirBookingNote $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirBookingNote) {
            throw new \InvalidArgumentException(sprintf('The AirBookingNote property can only contain items of type \StructType\AirBookingNote, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirBookingNote[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirBookingNote|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirBookingNote|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirBookingNote|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirBookingNote|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirBookingNote|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirBookingNote
     */
    public function getAttributeName()
    {
        return 'AirBookingNote';
    }
}
