<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirBookingPaxFare ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirBookingPaxFare
 * @subpackage Arrays
 */
class ArrayOfAirBookingPaxFare extends AbstractStructArrayBase
{
    /**
     * The AirBookingPaxFare
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirBookingPaxFare[]
     */
    public $AirBookingPaxFare;
    /**
     * Constructor method for ArrayOfAirBookingPaxFare
     * @uses ArrayOfAirBookingPaxFare::setAirBookingPaxFare()
     * @param \StructType\AirBookingPaxFare[] $airBookingPaxFare
     */
    public function __construct(array $airBookingPaxFare = array())
    {
        $this
            ->setAirBookingPaxFare($airBookingPaxFare);
    }
    /**
     * Get AirBookingPaxFare value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirBookingPaxFare[]|null
     */
    public function getAirBookingPaxFare()
    {
        return isset($this->AirBookingPaxFare) ? $this->AirBookingPaxFare : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirBookingPaxFare method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirBookingPaxFare method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirBookingPaxFareForArrayConstraintsFromSetAirBookingPaxFare(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirBookingPaxFareAirBookingPaxFareItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirBookingPaxFareAirBookingPaxFareItem instanceof \StructType\AirBookingPaxFare) {
                $invalidValues[] = is_object($arrayOfAirBookingPaxFareAirBookingPaxFareItem) ? get_class($arrayOfAirBookingPaxFareAirBookingPaxFareItem) : sprintf('%s(%s)', gettype($arrayOfAirBookingPaxFareAirBookingPaxFareItem), var_export($arrayOfAirBookingPaxFareAirBookingPaxFareItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirBookingPaxFare property can only contain items of type \StructType\AirBookingPaxFare, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirBookingPaxFare value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingPaxFare[] $airBookingPaxFare
     * @return \ArrayType\ArrayOfAirBookingPaxFare
     */
    public function setAirBookingPaxFare(array $airBookingPaxFare = array())
    {
        // validation for constraint: array
        if ('' !== ($airBookingPaxFareArrayErrorMessage = self::validateAirBookingPaxFareForArrayConstraintsFromSetAirBookingPaxFare($airBookingPaxFare))) {
            throw new \InvalidArgumentException($airBookingPaxFareArrayErrorMessage, __LINE__);
        }
        if (is_null($airBookingPaxFare) || (is_array($airBookingPaxFare) && empty($airBookingPaxFare))) {
            unset($this->AirBookingPaxFare);
        } else {
            $this->AirBookingPaxFare = $airBookingPaxFare;
        }
        return $this;
    }
    /**
     * Add item to AirBookingPaxFare value
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingPaxFare $item
     * @return \ArrayType\ArrayOfAirBookingPaxFare
     */
    public function addToAirBookingPaxFare(\StructType\AirBookingPaxFare $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirBookingPaxFare) {
            throw new \InvalidArgumentException(sprintf('The AirBookingPaxFare property can only contain items of type \StructType\AirBookingPaxFare, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirBookingPaxFare[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirBookingPaxFare|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirBookingPaxFare|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirBookingPaxFare|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirBookingPaxFare|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirBookingPaxFare|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirBookingPaxFare
     */
    public function getAttributeName()
    {
        return 'AirBookingPaxFare';
    }
}
