<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirBookingSearchItem ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirBookingSearchItem
 * @subpackage Arrays
 */
class ArrayOfAirBookingSearchItem extends AbstractStructArrayBase
{
    /**
     * The AirBookingSearchItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirBookingSearchItem[]
     */
    public $AirBookingSearchItem;
    /**
     * Constructor method for ArrayOfAirBookingSearchItem
     * @uses ArrayOfAirBookingSearchItem::setAirBookingSearchItem()
     * @param \StructType\AirBookingSearchItem[] $airBookingSearchItem
     */
    public function __construct(array $airBookingSearchItem = array())
    {
        $this
            ->setAirBookingSearchItem($airBookingSearchItem);
    }
    /**
     * Get AirBookingSearchItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirBookingSearchItem[]|null
     */
    public function getAirBookingSearchItem()
    {
        return isset($this->AirBookingSearchItem) ? $this->AirBookingSearchItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirBookingSearchItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirBookingSearchItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirBookingSearchItemForArrayConstraintsFromSetAirBookingSearchItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirBookingSearchItemAirBookingSearchItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirBookingSearchItemAirBookingSearchItemItem instanceof \StructType\AirBookingSearchItem) {
                $invalidValues[] = is_object($arrayOfAirBookingSearchItemAirBookingSearchItemItem) ? get_class($arrayOfAirBookingSearchItemAirBookingSearchItemItem) : sprintf('%s(%s)', gettype($arrayOfAirBookingSearchItemAirBookingSearchItemItem), var_export($arrayOfAirBookingSearchItemAirBookingSearchItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirBookingSearchItem property can only contain items of type \StructType\AirBookingSearchItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirBookingSearchItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingSearchItem[] $airBookingSearchItem
     * @return \ArrayType\ArrayOfAirBookingSearchItem
     */
    public function setAirBookingSearchItem(array $airBookingSearchItem = array())
    {
        // validation for constraint: array
        if ('' !== ($airBookingSearchItemArrayErrorMessage = self::validateAirBookingSearchItemForArrayConstraintsFromSetAirBookingSearchItem($airBookingSearchItem))) {
            throw new \InvalidArgumentException($airBookingSearchItemArrayErrorMessage, __LINE__);
        }
        if (is_null($airBookingSearchItem) || (is_array($airBookingSearchItem) && empty($airBookingSearchItem))) {
            unset($this->AirBookingSearchItem);
        } else {
            $this->AirBookingSearchItem = $airBookingSearchItem;
        }
        return $this;
    }
    /**
     * Add item to AirBookingSearchItem value
     * @throws \InvalidArgumentException
     * @param \StructType\AirBookingSearchItem $item
     * @return \ArrayType\ArrayOfAirBookingSearchItem
     */
    public function addToAirBookingSearchItem(\StructType\AirBookingSearchItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirBookingSearchItem) {
            throw new \InvalidArgumentException(sprintf('The AirBookingSearchItem property can only contain items of type \StructType\AirBookingSearchItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirBookingSearchItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirBookingSearchItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirBookingSearchItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirBookingSearchItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirBookingSearchItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirBookingSearchItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirBookingSearchItem
     */
    public function getAttributeName()
    {
        return 'AirBookingSearchItem';
    }
}
