<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirDestinationAirport ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirDestinationAirport
 * @subpackage Arrays
 */
class ArrayOfAirDestinationAirport extends AbstractStructArrayBase
{
    /**
     * The AirDestinationAirport
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirDestinationAirport[]
     */
    public $AirDestinationAirport;
    /**
     * Constructor method for ArrayOfAirDestinationAirport
     * @uses ArrayOfAirDestinationAirport::setAirDestinationAirport()
     * @param \StructType\AirDestinationAirport[] $airDestinationAirport
     */
    public function __construct(array $airDestinationAirport = array())
    {
        $this
            ->setAirDestinationAirport($airDestinationAirport);
    }
    /**
     * Get AirDestinationAirport value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirDestinationAirport[]|null
     */
    public function getAirDestinationAirport()
    {
        return isset($this->AirDestinationAirport) ? $this->AirDestinationAirport : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirDestinationAirport method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirDestinationAirport method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirDestinationAirportForArrayConstraintsFromSetAirDestinationAirport(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirDestinationAirportAirDestinationAirportItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirDestinationAirportAirDestinationAirportItem instanceof \StructType\AirDestinationAirport) {
                $invalidValues[] = is_object($arrayOfAirDestinationAirportAirDestinationAirportItem) ? get_class($arrayOfAirDestinationAirportAirDestinationAirportItem) : sprintf('%s(%s)', gettype($arrayOfAirDestinationAirportAirDestinationAirportItem), var_export($arrayOfAirDestinationAirportAirDestinationAirportItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirDestinationAirport property can only contain items of type \StructType\AirDestinationAirport, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirDestinationAirport value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirDestinationAirport[] $airDestinationAirport
     * @return \ArrayType\ArrayOfAirDestinationAirport
     */
    public function setAirDestinationAirport(array $airDestinationAirport = array())
    {
        // validation for constraint: array
        if ('' !== ($airDestinationAirportArrayErrorMessage = self::validateAirDestinationAirportForArrayConstraintsFromSetAirDestinationAirport($airDestinationAirport))) {
            throw new \InvalidArgumentException($airDestinationAirportArrayErrorMessage, __LINE__);
        }
        if (is_null($airDestinationAirport) || (is_array($airDestinationAirport) && empty($airDestinationAirport))) {
            unset($this->AirDestinationAirport);
        } else {
            $this->AirDestinationAirport = $airDestinationAirport;
        }
        return $this;
    }
    /**
     * Add item to AirDestinationAirport value
     * @throws \InvalidArgumentException
     * @param \StructType\AirDestinationAirport $item
     * @return \ArrayType\ArrayOfAirDestinationAirport
     */
    public function addToAirDestinationAirport(\StructType\AirDestinationAirport $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirDestinationAirport) {
            throw new \InvalidArgumentException(sprintf('The AirDestinationAirport property can only contain items of type \StructType\AirDestinationAirport, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirDestinationAirport[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirDestinationAirport|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirDestinationAirport|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirDestinationAirport|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirDestinationAirport|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirDestinationAirport|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirDestinationAirport
     */
    public function getAttributeName()
    {
        return 'AirDestinationAirport';
    }
}
