<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirFlightSegmentRQ ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirFlightSegmentRQ
 * @subpackage Arrays
 */
class ArrayOfAirFlightSegmentRQ extends AbstractStructArrayBase
{
    /**
     * The AirFlightSegmentRQ
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirFlightSegmentRQ[]
     */
    public $AirFlightSegmentRQ;
    /**
     * Constructor method for ArrayOfAirFlightSegmentRQ
     * @uses ArrayOfAirFlightSegmentRQ::setAirFlightSegmentRQ()
     * @param \StructType\AirFlightSegmentRQ[] $airFlightSegmentRQ
     */
    public function __construct(array $airFlightSegmentRQ = array())
    {
        $this
            ->setAirFlightSegmentRQ($airFlightSegmentRQ);
    }
    /**
     * Get AirFlightSegmentRQ value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirFlightSegmentRQ[]|null
     */
    public function getAirFlightSegmentRQ()
    {
        return isset($this->AirFlightSegmentRQ) ? $this->AirFlightSegmentRQ : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirFlightSegmentRQ method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirFlightSegmentRQ method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirFlightSegmentRQForArrayConstraintsFromSetAirFlightSegmentRQ(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirFlightSegmentRQAirFlightSegmentRQItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirFlightSegmentRQAirFlightSegmentRQItem instanceof \StructType\AirFlightSegmentRQ) {
                $invalidValues[] = is_object($arrayOfAirFlightSegmentRQAirFlightSegmentRQItem) ? get_class($arrayOfAirFlightSegmentRQAirFlightSegmentRQItem) : sprintf('%s(%s)', gettype($arrayOfAirFlightSegmentRQAirFlightSegmentRQItem), var_export($arrayOfAirFlightSegmentRQAirFlightSegmentRQItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirFlightSegmentRQ property can only contain items of type \StructType\AirFlightSegmentRQ, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirFlightSegmentRQ value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirFlightSegmentRQ[] $airFlightSegmentRQ
     * @return \ArrayType\ArrayOfAirFlightSegmentRQ
     */
    public function setAirFlightSegmentRQ(array $airFlightSegmentRQ = array())
    {
        // validation for constraint: array
        if ('' !== ($airFlightSegmentRQArrayErrorMessage = self::validateAirFlightSegmentRQForArrayConstraintsFromSetAirFlightSegmentRQ($airFlightSegmentRQ))) {
            throw new \InvalidArgumentException($airFlightSegmentRQArrayErrorMessage, __LINE__);
        }
        if (is_null($airFlightSegmentRQ) || (is_array($airFlightSegmentRQ) && empty($airFlightSegmentRQ))) {
            unset($this->AirFlightSegmentRQ);
        } else {
            $this->AirFlightSegmentRQ = $airFlightSegmentRQ;
        }
        return $this;
    }
    /**
     * Add item to AirFlightSegmentRQ value
     * @throws \InvalidArgumentException
     * @param \StructType\AirFlightSegmentRQ $item
     * @return \ArrayType\ArrayOfAirFlightSegmentRQ
     */
    public function addToAirFlightSegmentRQ(\StructType\AirFlightSegmentRQ $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirFlightSegmentRQ) {
            throw new \InvalidArgumentException(sprintf('The AirFlightSegmentRQ property can only contain items of type \StructType\AirFlightSegmentRQ, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirFlightSegmentRQ[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirFlightSegmentRQ|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirFlightSegmentRQ|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirFlightSegmentRQ|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirFlightSegmentRQ|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirFlightSegmentRQ|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirFlightSegmentRQ
     */
    public function getAttributeName()
    {
        return 'AirFlightSegmentRQ';
    }
}
