<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirFlightTicket ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirFlightTicket
 * @subpackage Arrays
 */
class ArrayOfAirFlightTicket extends AbstractStructArrayBase
{
    /**
     * The AirFlightTicket
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirFlightTicket[]
     */
    public $AirFlightTicket;
    /**
     * Constructor method for ArrayOfAirFlightTicket
     * @uses ArrayOfAirFlightTicket::setAirFlightTicket()
     * @param \StructType\AirFlightTicket[] $airFlightTicket
     */
    public function __construct(array $airFlightTicket = array())
    {
        $this
            ->setAirFlightTicket($airFlightTicket);
    }
    /**
     * Get AirFlightTicket value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirFlightTicket[]|null
     */
    public function getAirFlightTicket()
    {
        return isset($this->AirFlightTicket) ? $this->AirFlightTicket : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirFlightTicket method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirFlightTicket method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirFlightTicketForArrayConstraintsFromSetAirFlightTicket(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirFlightTicketAirFlightTicketItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirFlightTicketAirFlightTicketItem instanceof \StructType\AirFlightTicket) {
                $invalidValues[] = is_object($arrayOfAirFlightTicketAirFlightTicketItem) ? get_class($arrayOfAirFlightTicketAirFlightTicketItem) : sprintf('%s(%s)', gettype($arrayOfAirFlightTicketAirFlightTicketItem), var_export($arrayOfAirFlightTicketAirFlightTicketItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirFlightTicket property can only contain items of type \StructType\AirFlightTicket, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirFlightTicket value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirFlightTicket[] $airFlightTicket
     * @return \ArrayType\ArrayOfAirFlightTicket
     */
    public function setAirFlightTicket(array $airFlightTicket = array())
    {
        // validation for constraint: array
        if ('' !== ($airFlightTicketArrayErrorMessage = self::validateAirFlightTicketForArrayConstraintsFromSetAirFlightTicket($airFlightTicket))) {
            throw new \InvalidArgumentException($airFlightTicketArrayErrorMessage, __LINE__);
        }
        if (is_null($airFlightTicket) || (is_array($airFlightTicket) && empty($airFlightTicket))) {
            unset($this->AirFlightTicket);
        } else {
            $this->AirFlightTicket = $airFlightTicket;
        }
        return $this;
    }
    /**
     * Add item to AirFlightTicket value
     * @throws \InvalidArgumentException
     * @param \StructType\AirFlightTicket $item
     * @return \ArrayType\ArrayOfAirFlightTicket
     */
    public function addToAirFlightTicket(\StructType\AirFlightTicket $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirFlightTicket) {
            throw new \InvalidArgumentException(sprintf('The AirFlightTicket property can only contain items of type \StructType\AirFlightTicket, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirFlightTicket[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirFlightTicket|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirFlightTicket|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirFlightTicket|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirFlightTicket|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirFlightTicket|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirFlightTicket
     */
    public function getAttributeName()
    {
        return 'AirFlightTicket';
    }
}
