<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirItinerary ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirItinerary
 * @subpackage Arrays
 */
class ArrayOfAirItinerary extends AbstractStructArrayBase
{
    /**
     * The AirItinerary
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirItinerary[]
     */
    public $AirItinerary;
    /**
     * Constructor method for ArrayOfAirItinerary
     * @uses ArrayOfAirItinerary::setAirItinerary()
     * @param \StructType\AirItinerary[] $airItinerary
     */
    public function __construct(array $airItinerary = array())
    {
        $this
            ->setAirItinerary($airItinerary);
    }
    /**
     * Get AirItinerary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirItinerary[]|null
     */
    public function getAirItinerary()
    {
        return isset($this->AirItinerary) ? $this->AirItinerary : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirItinerary method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirItinerary method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirItineraryForArrayConstraintsFromSetAirItinerary(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirItineraryAirItineraryItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirItineraryAirItineraryItem instanceof \StructType\AirItinerary) {
                $invalidValues[] = is_object($arrayOfAirItineraryAirItineraryItem) ? get_class($arrayOfAirItineraryAirItineraryItem) : sprintf('%s(%s)', gettype($arrayOfAirItineraryAirItineraryItem), var_export($arrayOfAirItineraryAirItineraryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirItinerary property can only contain items of type \StructType\AirItinerary, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirItinerary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirItinerary[] $airItinerary
     * @return \ArrayType\ArrayOfAirItinerary
     */
    public function setAirItinerary(array $airItinerary = array())
    {
        // validation for constraint: array
        if ('' !== ($airItineraryArrayErrorMessage = self::validateAirItineraryForArrayConstraintsFromSetAirItinerary($airItinerary))) {
            throw new \InvalidArgumentException($airItineraryArrayErrorMessage, __LINE__);
        }
        if (is_null($airItinerary) || (is_array($airItinerary) && empty($airItinerary))) {
            unset($this->AirItinerary);
        } else {
            $this->AirItinerary = $airItinerary;
        }
        return $this;
    }
    /**
     * Add item to AirItinerary value
     * @throws \InvalidArgumentException
     * @param \StructType\AirItinerary $item
     * @return \ArrayType\ArrayOfAirItinerary
     */
    public function addToAirItinerary(\StructType\AirItinerary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirItinerary) {
            throw new \InvalidArgumentException(sprintf('The AirItinerary property can only contain items of type \StructType\AirItinerary, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirItinerary[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirItinerary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirItinerary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirItinerary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirItinerary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirItinerary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirItinerary
     */
    public function getAttributeName()
    {
        return 'AirItinerary';
    }
}
