<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirItineraryLeg ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirItineraryLeg
 * @subpackage Arrays
 */
class ArrayOfAirItineraryLeg extends AbstractStructArrayBase
{
    /**
     * The AirItineraryLeg
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirItineraryLeg[]
     */
    public $AirItineraryLeg;
    /**
     * Constructor method for ArrayOfAirItineraryLeg
     * @uses ArrayOfAirItineraryLeg::setAirItineraryLeg()
     * @param \StructType\AirItineraryLeg[] $airItineraryLeg
     */
    public function __construct(array $airItineraryLeg = array())
    {
        $this
            ->setAirItineraryLeg($airItineraryLeg);
    }
    /**
     * Get AirItineraryLeg value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirItineraryLeg[]|null
     */
    public function getAirItineraryLeg()
    {
        return isset($this->AirItineraryLeg) ? $this->AirItineraryLeg : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirItineraryLeg method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirItineraryLeg method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirItineraryLegForArrayConstraintsFromSetAirItineraryLeg(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirItineraryLegAirItineraryLegItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirItineraryLegAirItineraryLegItem instanceof \StructType\AirItineraryLeg) {
                $invalidValues[] = is_object($arrayOfAirItineraryLegAirItineraryLegItem) ? get_class($arrayOfAirItineraryLegAirItineraryLegItem) : sprintf('%s(%s)', gettype($arrayOfAirItineraryLegAirItineraryLegItem), var_export($arrayOfAirItineraryLegAirItineraryLegItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirItineraryLeg property can only contain items of type \StructType\AirItineraryLeg, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirItineraryLeg value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirItineraryLeg[] $airItineraryLeg
     * @return \ArrayType\ArrayOfAirItineraryLeg
     */
    public function setAirItineraryLeg(array $airItineraryLeg = array())
    {
        // validation for constraint: array
        if ('' !== ($airItineraryLegArrayErrorMessage = self::validateAirItineraryLegForArrayConstraintsFromSetAirItineraryLeg($airItineraryLeg))) {
            throw new \InvalidArgumentException($airItineraryLegArrayErrorMessage, __LINE__);
        }
        if (is_null($airItineraryLeg) || (is_array($airItineraryLeg) && empty($airItineraryLeg))) {
            unset($this->AirItineraryLeg);
        } else {
            $this->AirItineraryLeg = $airItineraryLeg;
        }
        return $this;
    }
    /**
     * Add item to AirItineraryLeg value
     * @throws \InvalidArgumentException
     * @param \StructType\AirItineraryLeg $item
     * @return \ArrayType\ArrayOfAirItineraryLeg
     */
    public function addToAirItineraryLeg(\StructType\AirItineraryLeg $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirItineraryLeg) {
            throw new \InvalidArgumentException(sprintf('The AirItineraryLeg property can only contain items of type \StructType\AirItineraryLeg, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirItineraryLeg[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirItineraryLeg|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirItineraryLeg|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirItineraryLeg|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirItineraryLeg|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirItineraryLeg|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirItineraryLeg
     */
    public function getAttributeName()
    {
        return 'AirItineraryLeg';
    }
}
