<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirMunicipalCode ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirMunicipalCode
 * @subpackage Arrays
 */
class ArrayOfAirMunicipalCode extends AbstractStructArrayBase
{
    /**
     * The AirMunicipalCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirMunicipalCode[]
     */
    public $AirMunicipalCode;
    /**
     * Constructor method for ArrayOfAirMunicipalCode
     * @uses ArrayOfAirMunicipalCode::setAirMunicipalCode()
     * @param \StructType\AirMunicipalCode[] $airMunicipalCode
     */
    public function __construct(array $airMunicipalCode = array())
    {
        $this
            ->setAirMunicipalCode($airMunicipalCode);
    }
    /**
     * Get AirMunicipalCode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirMunicipalCode[]|null
     */
    public function getAirMunicipalCode()
    {
        return isset($this->AirMunicipalCode) ? $this->AirMunicipalCode : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirMunicipalCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirMunicipalCode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirMunicipalCodeForArrayConstraintsFromSetAirMunicipalCode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirMunicipalCodeAirMunicipalCodeItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirMunicipalCodeAirMunicipalCodeItem instanceof \StructType\AirMunicipalCode) {
                $invalidValues[] = is_object($arrayOfAirMunicipalCodeAirMunicipalCodeItem) ? get_class($arrayOfAirMunicipalCodeAirMunicipalCodeItem) : sprintf('%s(%s)', gettype($arrayOfAirMunicipalCodeAirMunicipalCodeItem), var_export($arrayOfAirMunicipalCodeAirMunicipalCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirMunicipalCode property can only contain items of type \StructType\AirMunicipalCode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirMunicipalCode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirMunicipalCode[] $airMunicipalCode
     * @return \ArrayType\ArrayOfAirMunicipalCode
     */
    public function setAirMunicipalCode(array $airMunicipalCode = array())
    {
        // validation for constraint: array
        if ('' !== ($airMunicipalCodeArrayErrorMessage = self::validateAirMunicipalCodeForArrayConstraintsFromSetAirMunicipalCode($airMunicipalCode))) {
            throw new \InvalidArgumentException($airMunicipalCodeArrayErrorMessage, __LINE__);
        }
        if (is_null($airMunicipalCode) || (is_array($airMunicipalCode) && empty($airMunicipalCode))) {
            unset($this->AirMunicipalCode);
        } else {
            $this->AirMunicipalCode = $airMunicipalCode;
        }
        return $this;
    }
    /**
     * Add item to AirMunicipalCode value
     * @throws \InvalidArgumentException
     * @param \StructType\AirMunicipalCode $item
     * @return \ArrayType\ArrayOfAirMunicipalCode
     */
    public function addToAirMunicipalCode(\StructType\AirMunicipalCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirMunicipalCode) {
            throw new \InvalidArgumentException(sprintf('The AirMunicipalCode property can only contain items of type \StructType\AirMunicipalCode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirMunicipalCode[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirMunicipalCode|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirMunicipalCode|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirMunicipalCode|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirMunicipalCode|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirMunicipalCode|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirMunicipalCode
     */
    public function getAttributeName()
    {
        return 'AirMunicipalCode';
    }
}
