<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirPricedItinerary ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirPricedItinerary
 * @subpackage Arrays
 */
class ArrayOfAirPricedItinerary extends AbstractStructArrayBase
{
    /**
     * The AirPricedItinerary
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirPricedItinerary[]
     */
    public $AirPricedItinerary;
    /**
     * Constructor method for ArrayOfAirPricedItinerary
     * @uses ArrayOfAirPricedItinerary::setAirPricedItinerary()
     * @param \StructType\AirPricedItinerary[] $airPricedItinerary
     */
    public function __construct(array $airPricedItinerary = array())
    {
        $this
            ->setAirPricedItinerary($airPricedItinerary);
    }
    /**
     * Get AirPricedItinerary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirPricedItinerary[]|null
     */
    public function getAirPricedItinerary()
    {
        return isset($this->AirPricedItinerary) ? $this->AirPricedItinerary : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirPricedItinerary method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirPricedItinerary method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirPricedItineraryForArrayConstraintsFromSetAirPricedItinerary(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirPricedItineraryAirPricedItineraryItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirPricedItineraryAirPricedItineraryItem instanceof \StructType\AirPricedItinerary) {
                $invalidValues[] = is_object($arrayOfAirPricedItineraryAirPricedItineraryItem) ? get_class($arrayOfAirPricedItineraryAirPricedItineraryItem) : sprintf('%s(%s)', gettype($arrayOfAirPricedItineraryAirPricedItineraryItem), var_export($arrayOfAirPricedItineraryAirPricedItineraryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirPricedItinerary property can only contain items of type \StructType\AirPricedItinerary, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirPricedItinerary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirPricedItinerary[] $airPricedItinerary
     * @return \ArrayType\ArrayOfAirPricedItinerary
     */
    public function setAirPricedItinerary(array $airPricedItinerary = array())
    {
        // validation for constraint: array
        if ('' !== ($airPricedItineraryArrayErrorMessage = self::validateAirPricedItineraryForArrayConstraintsFromSetAirPricedItinerary($airPricedItinerary))) {
            throw new \InvalidArgumentException($airPricedItineraryArrayErrorMessage, __LINE__);
        }
        if (is_null($airPricedItinerary) || (is_array($airPricedItinerary) && empty($airPricedItinerary))) {
            unset($this->AirPricedItinerary);
        } else {
            $this->AirPricedItinerary = $airPricedItinerary;
        }
        return $this;
    }
    /**
     * Add item to AirPricedItinerary value
     * @throws \InvalidArgumentException
     * @param \StructType\AirPricedItinerary $item
     * @return \ArrayType\ArrayOfAirPricedItinerary
     */
    public function addToAirPricedItinerary(\StructType\AirPricedItinerary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirPricedItinerary) {
            throw new \InvalidArgumentException(sprintf('The AirPricedItinerary property can only contain items of type \StructType\AirPricedItinerary, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirPricedItinerary[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirPricedItinerary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirPricedItinerary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirPricedItinerary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirPricedItinerary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirPricedItinerary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirPricedItinerary
     */
    public function getAttributeName()
    {
        return 'AirPricedItinerary';
    }
}
