<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirPricedItineraryLeg ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirPricedItineraryLeg
 * @subpackage Arrays
 */
class ArrayOfAirPricedItineraryLeg extends AbstractStructArrayBase
{
    /**
     * The AirPricedItineraryLeg
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirPricedItineraryLeg[]
     */
    public $AirPricedItineraryLeg;
    /**
     * Constructor method for ArrayOfAirPricedItineraryLeg
     * @uses ArrayOfAirPricedItineraryLeg::setAirPricedItineraryLeg()
     * @param \StructType\AirPricedItineraryLeg[] $airPricedItineraryLeg
     */
    public function __construct(array $airPricedItineraryLeg = array())
    {
        $this
            ->setAirPricedItineraryLeg($airPricedItineraryLeg);
    }
    /**
     * Get AirPricedItineraryLeg value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirPricedItineraryLeg[]|null
     */
    public function getAirPricedItineraryLeg()
    {
        return isset($this->AirPricedItineraryLeg) ? $this->AirPricedItineraryLeg : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirPricedItineraryLeg method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirPricedItineraryLeg method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirPricedItineraryLegForArrayConstraintsFromSetAirPricedItineraryLeg(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirPricedItineraryLegAirPricedItineraryLegItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirPricedItineraryLegAirPricedItineraryLegItem instanceof \StructType\AirPricedItineraryLeg) {
                $invalidValues[] = is_object($arrayOfAirPricedItineraryLegAirPricedItineraryLegItem) ? get_class($arrayOfAirPricedItineraryLegAirPricedItineraryLegItem) : sprintf('%s(%s)', gettype($arrayOfAirPricedItineraryLegAirPricedItineraryLegItem), var_export($arrayOfAirPricedItineraryLegAirPricedItineraryLegItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirPricedItineraryLeg property can only contain items of type \StructType\AirPricedItineraryLeg, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirPricedItineraryLeg value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirPricedItineraryLeg[] $airPricedItineraryLeg
     * @return \ArrayType\ArrayOfAirPricedItineraryLeg
     */
    public function setAirPricedItineraryLeg(array $airPricedItineraryLeg = array())
    {
        // validation for constraint: array
        if ('' !== ($airPricedItineraryLegArrayErrorMessage = self::validateAirPricedItineraryLegForArrayConstraintsFromSetAirPricedItineraryLeg($airPricedItineraryLeg))) {
            throw new \InvalidArgumentException($airPricedItineraryLegArrayErrorMessage, __LINE__);
        }
        if (is_null($airPricedItineraryLeg) || (is_array($airPricedItineraryLeg) && empty($airPricedItineraryLeg))) {
            unset($this->AirPricedItineraryLeg);
        } else {
            $this->AirPricedItineraryLeg = $airPricedItineraryLeg;
        }
        return $this;
    }
    /**
     * Add item to AirPricedItineraryLeg value
     * @throws \InvalidArgumentException
     * @param \StructType\AirPricedItineraryLeg $item
     * @return \ArrayType\ArrayOfAirPricedItineraryLeg
     */
    public function addToAirPricedItineraryLeg(\StructType\AirPricedItineraryLeg $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirPricedItineraryLeg) {
            throw new \InvalidArgumentException(sprintf('The AirPricedItineraryLeg property can only contain items of type \StructType\AirPricedItineraryLeg, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirPricedItineraryLeg[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirPricedItineraryLeg|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirPricedItineraryLeg|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirPricedItineraryLeg|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirPricedItineraryLeg|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirPricedItineraryLeg|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirPricedItineraryLeg
     */
    public function getAttributeName()
    {
        return 'AirPricedItineraryLeg';
    }
}
