<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirPricingGroup ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirPricingGroup
 * @subpackage Arrays
 */
class ArrayOfAirPricingGroup extends AbstractStructArrayBase
{
    /**
     * The AirPricingGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirPricingGroup[]
     */
    public $AirPricingGroup;
    /**
     * Constructor method for ArrayOfAirPricingGroup
     * @uses ArrayOfAirPricingGroup::setAirPricingGroup()
     * @param \StructType\AirPricingGroup[] $airPricingGroup
     */
    public function __construct(array $airPricingGroup = array())
    {
        $this
            ->setAirPricingGroup($airPricingGroup);
    }
    /**
     * Get AirPricingGroup value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirPricingGroup[]|null
     */
    public function getAirPricingGroup()
    {
        return isset($this->AirPricingGroup) ? $this->AirPricingGroup : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirPricingGroup method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirPricingGroup method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirPricingGroupForArrayConstraintsFromSetAirPricingGroup(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirPricingGroupAirPricingGroupItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirPricingGroupAirPricingGroupItem instanceof \StructType\AirPricingGroup) {
                $invalidValues[] = is_object($arrayOfAirPricingGroupAirPricingGroupItem) ? get_class($arrayOfAirPricingGroupAirPricingGroupItem) : sprintf('%s(%s)', gettype($arrayOfAirPricingGroupAirPricingGroupItem), var_export($arrayOfAirPricingGroupAirPricingGroupItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirPricingGroup property can only contain items of type \StructType\AirPricingGroup, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirPricingGroup value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirPricingGroup[] $airPricingGroup
     * @return \ArrayType\ArrayOfAirPricingGroup
     */
    public function setAirPricingGroup(array $airPricingGroup = array())
    {
        // validation for constraint: array
        if ('' !== ($airPricingGroupArrayErrorMessage = self::validateAirPricingGroupForArrayConstraintsFromSetAirPricingGroup($airPricingGroup))) {
            throw new \InvalidArgumentException($airPricingGroupArrayErrorMessage, __LINE__);
        }
        if (is_null($airPricingGroup) || (is_array($airPricingGroup) && empty($airPricingGroup))) {
            unset($this->AirPricingGroup);
        } else {
            $this->AirPricingGroup = $airPricingGroup;
        }
        return $this;
    }
    /**
     * Add item to AirPricingGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\AirPricingGroup $item
     * @return \ArrayType\ArrayOfAirPricingGroup
     */
    public function addToAirPricingGroup(\StructType\AirPricingGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirPricingGroup) {
            throw new \InvalidArgumentException(sprintf('The AirPricingGroup property can only contain items of type \StructType\AirPricingGroup, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirPricingGroup[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirPricingGroup|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirPricingGroup|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirPricingGroup|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirPricingGroup|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirPricingGroup|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirPricingGroup
     */
    public function getAttributeName()
    {
        return 'AirPricingGroup';
    }
}
