<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirPricingGroupOption ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirPricingGroupOption
 * @subpackage Arrays
 */
class ArrayOfAirPricingGroupOption extends AbstractStructArrayBase
{
    /**
     * The AirPricingGroupOption
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirPricingGroupOption[]
     */
    public $AirPricingGroupOption;
    /**
     * Constructor method for ArrayOfAirPricingGroupOption
     * @uses ArrayOfAirPricingGroupOption::setAirPricingGroupOption()
     * @param \StructType\AirPricingGroupOption[] $airPricingGroupOption
     */
    public function __construct(array $airPricingGroupOption = array())
    {
        $this
            ->setAirPricingGroupOption($airPricingGroupOption);
    }
    /**
     * Get AirPricingGroupOption value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirPricingGroupOption[]|null
     */
    public function getAirPricingGroupOption()
    {
        return isset($this->AirPricingGroupOption) ? $this->AirPricingGroupOption : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirPricingGroupOption method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirPricingGroupOption method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirPricingGroupOptionForArrayConstraintsFromSetAirPricingGroupOption(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirPricingGroupOptionAirPricingGroupOptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirPricingGroupOptionAirPricingGroupOptionItem instanceof \StructType\AirPricingGroupOption) {
                $invalidValues[] = is_object($arrayOfAirPricingGroupOptionAirPricingGroupOptionItem) ? get_class($arrayOfAirPricingGroupOptionAirPricingGroupOptionItem) : sprintf('%s(%s)', gettype($arrayOfAirPricingGroupOptionAirPricingGroupOptionItem), var_export($arrayOfAirPricingGroupOptionAirPricingGroupOptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirPricingGroupOption property can only contain items of type \StructType\AirPricingGroupOption, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirPricingGroupOption value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirPricingGroupOption[] $airPricingGroupOption
     * @return \ArrayType\ArrayOfAirPricingGroupOption
     */
    public function setAirPricingGroupOption(array $airPricingGroupOption = array())
    {
        // validation for constraint: array
        if ('' !== ($airPricingGroupOptionArrayErrorMessage = self::validateAirPricingGroupOptionForArrayConstraintsFromSetAirPricingGroupOption($airPricingGroupOption))) {
            throw new \InvalidArgumentException($airPricingGroupOptionArrayErrorMessage, __LINE__);
        }
        if (is_null($airPricingGroupOption) || (is_array($airPricingGroupOption) && empty($airPricingGroupOption))) {
            unset($this->AirPricingGroupOption);
        } else {
            $this->AirPricingGroupOption = $airPricingGroupOption;
        }
        return $this;
    }
    /**
     * Add item to AirPricingGroupOption value
     * @throws \InvalidArgumentException
     * @param \StructType\AirPricingGroupOption $item
     * @return \ArrayType\ArrayOfAirPricingGroupOption
     */
    public function addToAirPricingGroupOption(\StructType\AirPricingGroupOption $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirPricingGroupOption) {
            throw new \InvalidArgumentException(sprintf('The AirPricingGroupOption property can only contain items of type \StructType\AirPricingGroupOption, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirPricingGroupOption[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirPricingGroupOption|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirPricingGroupOption|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirPricingGroupOption|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirPricingGroupOption|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirPricingGroupOption|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirPricingGroupOption
     */
    public function getAttributeName()
    {
        return 'AirPricingGroupOption';
    }
}
