<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirTechnicalStop ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirTechnicalStop
 * @subpackage Arrays
 */
class ArrayOfAirTechnicalStop extends AbstractStructArrayBase
{
    /**
     * The AirTechnicalStop
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirTechnicalStop[]
     */
    public $AirTechnicalStop;
    /**
     * Constructor method for ArrayOfAirTechnicalStop
     * @uses ArrayOfAirTechnicalStop::setAirTechnicalStop()
     * @param \StructType\AirTechnicalStop[] $airTechnicalStop
     */
    public function __construct(array $airTechnicalStop = array())
    {
        $this
            ->setAirTechnicalStop($airTechnicalStop);
    }
    /**
     * Get AirTechnicalStop value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirTechnicalStop[]|null
     */
    public function getAirTechnicalStop()
    {
        return isset($this->AirTechnicalStop) ? $this->AirTechnicalStop : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirTechnicalStop method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirTechnicalStop method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirTechnicalStopForArrayConstraintsFromSetAirTechnicalStop(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirTechnicalStopAirTechnicalStopItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirTechnicalStopAirTechnicalStopItem instanceof \StructType\AirTechnicalStop) {
                $invalidValues[] = is_object($arrayOfAirTechnicalStopAirTechnicalStopItem) ? get_class($arrayOfAirTechnicalStopAirTechnicalStopItem) : sprintf('%s(%s)', gettype($arrayOfAirTechnicalStopAirTechnicalStopItem), var_export($arrayOfAirTechnicalStopAirTechnicalStopItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirTechnicalStop property can only contain items of type \StructType\AirTechnicalStop, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirTechnicalStop value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirTechnicalStop[] $airTechnicalStop
     * @return \ArrayType\ArrayOfAirTechnicalStop
     */
    public function setAirTechnicalStop(array $airTechnicalStop = array())
    {
        // validation for constraint: array
        if ('' !== ($airTechnicalStopArrayErrorMessage = self::validateAirTechnicalStopForArrayConstraintsFromSetAirTechnicalStop($airTechnicalStop))) {
            throw new \InvalidArgumentException($airTechnicalStopArrayErrorMessage, __LINE__);
        }
        if (is_null($airTechnicalStop) || (is_array($airTechnicalStop) && empty($airTechnicalStop))) {
            unset($this->AirTechnicalStop);
        } else {
            $this->AirTechnicalStop = $airTechnicalStop;
        }
        return $this;
    }
    /**
     * Add item to AirTechnicalStop value
     * @throws \InvalidArgumentException
     * @param \StructType\AirTechnicalStop $item
     * @return \ArrayType\ArrayOfAirTechnicalStop
     */
    public function addToAirTechnicalStop(\StructType\AirTechnicalStop $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirTechnicalStop) {
            throw new \InvalidArgumentException(sprintf('The AirTechnicalStop property can only contain items of type \StructType\AirTechnicalStop, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirTechnicalStop[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirTechnicalStop|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirTechnicalStop|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirTechnicalStop|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirTechnicalStop|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirTechnicalStop|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirTechnicalStop
     */
    public function getAttributeName()
    {
        return 'AirTechnicalStop';
    }
}
