<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirTraveler ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirTraveler
 * @subpackage Arrays
 */
class ArrayOfAirTraveler extends AbstractStructArrayBase
{
    /**
     * The AirTraveler
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirTraveler[]
     */
    public $AirTraveler;
    /**
     * Constructor method for ArrayOfAirTraveler
     * @uses ArrayOfAirTraveler::setAirTraveler()
     * @param \StructType\AirTraveler[] $airTraveler
     */
    public function __construct(array $airTraveler = array())
    {
        $this
            ->setAirTraveler($airTraveler);
    }
    /**
     * Get AirTraveler value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirTraveler[]|null
     */
    public function getAirTraveler()
    {
        return isset($this->AirTraveler) ? $this->AirTraveler : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirTraveler method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirTraveler method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirTravelerForArrayConstraintsFromSetAirTraveler(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirTravelerAirTravelerItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirTravelerAirTravelerItem instanceof \StructType\AirTraveler) {
                $invalidValues[] = is_object($arrayOfAirTravelerAirTravelerItem) ? get_class($arrayOfAirTravelerAirTravelerItem) : sprintf('%s(%s)', gettype($arrayOfAirTravelerAirTravelerItem), var_export($arrayOfAirTravelerAirTravelerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirTraveler property can only contain items of type \StructType\AirTraveler, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirTraveler value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirTraveler[] $airTraveler
     * @return \ArrayType\ArrayOfAirTraveler
     */
    public function setAirTraveler(array $airTraveler = array())
    {
        // validation for constraint: array
        if ('' !== ($airTravelerArrayErrorMessage = self::validateAirTravelerForArrayConstraintsFromSetAirTraveler($airTraveler))) {
            throw new \InvalidArgumentException($airTravelerArrayErrorMessage, __LINE__);
        }
        if (is_null($airTraveler) || (is_array($airTraveler) && empty($airTraveler))) {
            unset($this->AirTraveler);
        } else {
            $this->AirTraveler = $airTraveler;
        }
        return $this;
    }
    /**
     * Add item to AirTraveler value
     * @throws \InvalidArgumentException
     * @param \StructType\AirTraveler $item
     * @return \ArrayType\ArrayOfAirTraveler
     */
    public function addToAirTraveler(\StructType\AirTraveler $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirTraveler) {
            throw new \InvalidArgumentException(sprintf('The AirTraveler property can only contain items of type \StructType\AirTraveler, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirTraveler[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirTraveler|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirTraveler|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirTraveler|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirTraveler|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirTraveler|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirTraveler
     */
    public function getAttributeName()
    {
        return 'AirTraveler';
    }
}
