<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirTravelerAncillary ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirTravelerAncillary
 * @subpackage Arrays
 */
class ArrayOfAirTravelerAncillary extends AbstractStructArrayBase
{
    /**
     * The AirTravelerAncillary
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirTravelerAncillary[]
     */
    public $AirTravelerAncillary;
    /**
     * Constructor method for ArrayOfAirTravelerAncillary
     * @uses ArrayOfAirTravelerAncillary::setAirTravelerAncillary()
     * @param \StructType\AirTravelerAncillary[] $airTravelerAncillary
     */
    public function __construct(array $airTravelerAncillary = array())
    {
        $this
            ->setAirTravelerAncillary($airTravelerAncillary);
    }
    /**
     * Get AirTravelerAncillary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirTravelerAncillary[]|null
     */
    public function getAirTravelerAncillary()
    {
        return isset($this->AirTravelerAncillary) ? $this->AirTravelerAncillary : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirTravelerAncillary method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirTravelerAncillary method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirTravelerAncillaryForArrayConstraintsFromSetAirTravelerAncillary(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirTravelerAncillaryAirTravelerAncillaryItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirTravelerAncillaryAirTravelerAncillaryItem instanceof \StructType\AirTravelerAncillary) {
                $invalidValues[] = is_object($arrayOfAirTravelerAncillaryAirTravelerAncillaryItem) ? get_class($arrayOfAirTravelerAncillaryAirTravelerAncillaryItem) : sprintf('%s(%s)', gettype($arrayOfAirTravelerAncillaryAirTravelerAncillaryItem), var_export($arrayOfAirTravelerAncillaryAirTravelerAncillaryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirTravelerAncillary property can only contain items of type \StructType\AirTravelerAncillary, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirTravelerAncillary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirTravelerAncillary[] $airTravelerAncillary
     * @return \ArrayType\ArrayOfAirTravelerAncillary
     */
    public function setAirTravelerAncillary(array $airTravelerAncillary = array())
    {
        // validation for constraint: array
        if ('' !== ($airTravelerAncillaryArrayErrorMessage = self::validateAirTravelerAncillaryForArrayConstraintsFromSetAirTravelerAncillary($airTravelerAncillary))) {
            throw new \InvalidArgumentException($airTravelerAncillaryArrayErrorMessage, __LINE__);
        }
        if (is_null($airTravelerAncillary) || (is_array($airTravelerAncillary) && empty($airTravelerAncillary))) {
            unset($this->AirTravelerAncillary);
        } else {
            $this->AirTravelerAncillary = $airTravelerAncillary;
        }
        return $this;
    }
    /**
     * Add item to AirTravelerAncillary value
     * @throws \InvalidArgumentException
     * @param \StructType\AirTravelerAncillary $item
     * @return \ArrayType\ArrayOfAirTravelerAncillary
     */
    public function addToAirTravelerAncillary(\StructType\AirTravelerAncillary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirTravelerAncillary) {
            throw new \InvalidArgumentException(sprintf('The AirTravelerAncillary property can only contain items of type \StructType\AirTravelerAncillary, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirTravelerAncillary[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirTravelerAncillary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirTravelerAncillary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirTravelerAncillary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirTravelerAncillary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirTravelerAncillary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirTravelerAncillary
     */
    public function getAttributeName()
    {
        return 'AirTravelerAncillary';
    }
}
