<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirTravelerFlightSegmentLeg ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirTravelerFlightSegmentLeg
 * @subpackage Arrays
 */
class ArrayOfAirTravelerFlightSegmentLeg extends AbstractStructArrayBase
{
    /**
     * The AirTravelerFlightSegmentLeg
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirTravelerFlightSegmentLeg[]
     */
    public $AirTravelerFlightSegmentLeg;
    /**
     * Constructor method for ArrayOfAirTravelerFlightSegmentLeg
     * @uses ArrayOfAirTravelerFlightSegmentLeg::setAirTravelerFlightSegmentLeg()
     * @param \StructType\AirTravelerFlightSegmentLeg[] $airTravelerFlightSegmentLeg
     */
    public function __construct(array $airTravelerFlightSegmentLeg = array())
    {
        $this
            ->setAirTravelerFlightSegmentLeg($airTravelerFlightSegmentLeg);
    }
    /**
     * Get AirTravelerFlightSegmentLeg value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirTravelerFlightSegmentLeg[]|null
     */
    public function getAirTravelerFlightSegmentLeg()
    {
        return isset($this->AirTravelerFlightSegmentLeg) ? $this->AirTravelerFlightSegmentLeg : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirTravelerFlightSegmentLeg method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirTravelerFlightSegmentLeg method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirTravelerFlightSegmentLegForArrayConstraintsFromSetAirTravelerFlightSegmentLeg(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirTravelerFlightSegmentLegAirTravelerFlightSegmentLegItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirTravelerFlightSegmentLegAirTravelerFlightSegmentLegItem instanceof \StructType\AirTravelerFlightSegmentLeg) {
                $invalidValues[] = is_object($arrayOfAirTravelerFlightSegmentLegAirTravelerFlightSegmentLegItem) ? get_class($arrayOfAirTravelerFlightSegmentLegAirTravelerFlightSegmentLegItem) : sprintf('%s(%s)', gettype($arrayOfAirTravelerFlightSegmentLegAirTravelerFlightSegmentLegItem), var_export($arrayOfAirTravelerFlightSegmentLegAirTravelerFlightSegmentLegItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirTravelerFlightSegmentLeg property can only contain items of type \StructType\AirTravelerFlightSegmentLeg, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirTravelerFlightSegmentLeg value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirTravelerFlightSegmentLeg[] $airTravelerFlightSegmentLeg
     * @return \ArrayType\ArrayOfAirTravelerFlightSegmentLeg
     */
    public function setAirTravelerFlightSegmentLeg(array $airTravelerFlightSegmentLeg = array())
    {
        // validation for constraint: array
        if ('' !== ($airTravelerFlightSegmentLegArrayErrorMessage = self::validateAirTravelerFlightSegmentLegForArrayConstraintsFromSetAirTravelerFlightSegmentLeg($airTravelerFlightSegmentLeg))) {
            throw new \InvalidArgumentException($airTravelerFlightSegmentLegArrayErrorMessage, __LINE__);
        }
        if (is_null($airTravelerFlightSegmentLeg) || (is_array($airTravelerFlightSegmentLeg) && empty($airTravelerFlightSegmentLeg))) {
            unset($this->AirTravelerFlightSegmentLeg);
        } else {
            $this->AirTravelerFlightSegmentLeg = $airTravelerFlightSegmentLeg;
        }
        return $this;
    }
    /**
     * Add item to AirTravelerFlightSegmentLeg value
     * @throws \InvalidArgumentException
     * @param \StructType\AirTravelerFlightSegmentLeg $item
     * @return \ArrayType\ArrayOfAirTravelerFlightSegmentLeg
     */
    public function addToAirTravelerFlightSegmentLeg(\StructType\AirTravelerFlightSegmentLeg $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirTravelerFlightSegmentLeg) {
            throw new \InvalidArgumentException(sprintf('The AirTravelerFlightSegmentLeg property can only contain items of type \StructType\AirTravelerFlightSegmentLeg, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirTravelerFlightSegmentLeg[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirTravelerFlightSegmentLeg|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirTravelerFlightSegmentLeg|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirTravelerFlightSegmentLeg|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirTravelerFlightSegmentLeg|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirTravelerFlightSegmentLeg|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirTravelerFlightSegmentLeg
     */
    public function getAttributeName()
    {
        return 'AirTravelerFlightSegmentLeg';
    }
}
