<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirTravelerInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirTravelerInfo
 * @subpackage Arrays
 */
class ArrayOfAirTravelerInfo extends AbstractStructArrayBase
{
    /**
     * The AirTravelerInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirTravelerInfo[]
     */
    public $AirTravelerInfo;
    /**
     * Constructor method for ArrayOfAirTravelerInfo
     * @uses ArrayOfAirTravelerInfo::setAirTravelerInfo()
     * @param \StructType\AirTravelerInfo[] $airTravelerInfo
     */
    public function __construct(array $airTravelerInfo = array())
    {
        $this
            ->setAirTravelerInfo($airTravelerInfo);
    }
    /**
     * Get AirTravelerInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirTravelerInfo[]|null
     */
    public function getAirTravelerInfo()
    {
        return isset($this->AirTravelerInfo) ? $this->AirTravelerInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAirTravelerInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAirTravelerInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAirTravelerInfoForArrayConstraintsFromSetAirTravelerInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAirTravelerInfoAirTravelerInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirTravelerInfoAirTravelerInfoItem instanceof \StructType\AirTravelerInfo) {
                $invalidValues[] = is_object($arrayOfAirTravelerInfoAirTravelerInfoItem) ? get_class($arrayOfAirTravelerInfoAirTravelerInfoItem) : sprintf('%s(%s)', gettype($arrayOfAirTravelerInfoAirTravelerInfoItem), var_export($arrayOfAirTravelerInfoAirTravelerInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AirTravelerInfo property can only contain items of type \StructType\AirTravelerInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AirTravelerInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirTravelerInfo[] $airTravelerInfo
     * @return \ArrayType\ArrayOfAirTravelerInfo
     */
    public function setAirTravelerInfo(array $airTravelerInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($airTravelerInfoArrayErrorMessage = self::validateAirTravelerInfoForArrayConstraintsFromSetAirTravelerInfo($airTravelerInfo))) {
            throw new \InvalidArgumentException($airTravelerInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($airTravelerInfo) || (is_array($airTravelerInfo) && empty($airTravelerInfo))) {
            unset($this->AirTravelerInfo);
        } else {
            $this->AirTravelerInfo = $airTravelerInfo;
        }
        return $this;
    }
    /**
     * Add item to AirTravelerInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\AirTravelerInfo $item
     * @return \ArrayType\ArrayOfAirTravelerInfo
     */
    public function addToAirTravelerInfo(\StructType\AirTravelerInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirTravelerInfo) {
            throw new \InvalidArgumentException(sprintf('The AirTravelerInfo property can only contain items of type \StructType\AirTravelerInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AirTravelerInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirTravelerInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirTravelerInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirTravelerInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirTravelerInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirTravelerInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirTravelerInfo
     */
    public function getAttributeName()
    {
        return 'AirTravelerInfo';
    }
}
