<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'AirDestinationAirportsList' => '\\StructType\\AirDestinationAirportsList',
            'AuthenticationCredentials' => '\\StructType\\AuthenticationCredentials',
            'AirDestinationAirportsListResponse' => '\\StructType\\AirDestinationAirportsListResponse',
            'ArrayOfAirDestinationAirport' => '\\ArrayType\\ArrayOfAirDestinationAirport',
            'AirDestinationAirport' => '\\StructType\\AirDestinationAirport',
            'AirlineCarriersList' => '\\StructType\\AirlineCarriersList',
            'AirlineCarriersListResponse' => '\\StructType\\AirlineCarriersListResponse',
            'ArrayOfAirAirlineCarrier' => '\\ArrayType\\ArrayOfAirAirlineCarrier',
            'AirAirlineCarrier' => '\\StructType\\AirAirlineCarrier',
            'AirMunicipalCodeList' => '\\StructType\\AirMunicipalCodeList',
            'AirMunicipalCodeListResponse' => '\\StructType\\AirMunicipalCodeListResponse',
            'ArrayOfAirMunicipalCode' => '\\ArrayType\\ArrayOfAirMunicipalCode',
            'AirMunicipalCode' => '\\StructType\\AirMunicipalCode',
            'AirAvailSearch' => '\\StructType\\AirAvailSearch',
            'AirAvailRQ' => '\\StructType\\AirAvailRQ',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString_1',
            'ArrayOfAirTravelerInfo' => '\\ArrayType\\ArrayOfAirTravelerInfo',
            'AirTravelerInfo' => '\\StructType\\AirTravelerInfo',
            'ArrayOfAirFlightSegmentRQ' => '\\ArrayType\\ArrayOfAirFlightSegmentRQ',
            'AirFlightSegmentRQ' => '\\StructType\\AirFlightSegmentRQ',
            'AirAvailSearchResponse' => '\\StructType\\AirAvailSearchResponse',
            'AirAvailRS' => '\\StructType\\AirAvailRS',
            'AirAvail' => '\\StructType\\AirAvail',
            'ArrayOfWarning' => '\\ArrayType\\ArrayOfWarning',
            'Warning' => '\\StructType\\Warning',
            'ArrayOfAirItinerary' => '\\ArrayType\\ArrayOfAirItinerary',
            'AirItinerary' => '\\StructType\\AirItinerary',
            'ArrayOfAirItineraryLeg' => '\\ArrayType\\ArrayOfAirItineraryLeg',
            'AirItineraryLeg' => '\\StructType\\AirItineraryLeg',
            'ArrayOfAirTechnicalStop' => '\\ArrayType\\ArrayOfAirTechnicalStop',
            'AirTechnicalStop' => '\\StructType\\AirTechnicalStop',
            'ArrayOfAirPricingGroup' => '\\ArrayType\\ArrayOfAirPricingGroup',
            'AirPricingGroup' => '\\StructType\\AirPricingGroup',
            'ArrayOfAirFareNote' => '\\ArrayType\\ArrayOfAirFareNote',
            'AirFareNote' => '\\StructType\\AirFareNote',
            'ArrayOfAirPricingGroupOption' => '\\ArrayType\\ArrayOfAirPricingGroupOption',
            'AirPricingGroupOption' => '\\StructType\\AirPricingGroupOption',
            'ArrayOfAirPricedItinerary' => '\\ArrayType\\ArrayOfAirPricedItinerary',
            'AirPricedItinerary' => '\\StructType\\AirPricedItinerary',
            'ArrayOfAirPricedItineraryLeg' => '\\ArrayType\\ArrayOfAirPricedItineraryLeg',
            'AirPricedItineraryLeg' => '\\StructType\\AirPricedItineraryLeg',
            'ArrayOfAirCalendarCombination' => '\\ArrayType\\ArrayOfAirCalendarCombination',
            'AirCalendarCombination' => '\\StructType\\AirCalendarCombination',
            'ResponseError' => '\\StructType\\ResponseError',
            'AirAvailMultiSegmentSearch' => '\\StructType\\AirAvailMultiSegmentSearch',
            'AirAvailMultiSegmentSearchResponse' => '\\StructType\\AirAvailMultiSegmentSearchResponse',
            'AirAvailCalendarSearch' => '\\StructType\\AirAvailCalendarSearch',
            'AirAvailCalendarSearchResponse' => '\\StructType\\AirAvailCalendarSearchResponse',
            'AirAvailGetRateNotes' => '\\StructType\\AirAvailGetRateNotes',
            'AirAvailRateNotesRQ' => '\\StructType\\AirAvailRateNotesRQ',
            'ArrayOfInt' => '\\ArrayType\\ArrayOfInt',
            'AirAvailGetRateNotesResponse' => '\\StructType\\AirAvailGetRateNotesResponse',
            'AirBookingRateNotesRS' => '\\StructType\\AirBookingRateNotesRS',
            'AirAvailGetFareFamilies' => '\\StructType\\AirAvailGetFareFamilies',
            'AirAvailFareFamiliesRQ' => '\\StructType\\AirAvailFareFamiliesRQ',
            'AirAvailGetFareFamiliesResponse' => '\\StructType\\AirAvailGetFareFamiliesResponse',
            'AirAvailFareFamiliesRS' => '\\StructType\\AirAvailFareFamiliesRS',
            'ArrayOfAirAvailFareFamiliesOptions' => '\\ArrayType\\ArrayOfAirAvailFareFamiliesOptions',
            'AirAvailFareFamiliesOptions' => '\\StructType\\AirAvailFareFamiliesOptions',
            'ArrayOfAirFareFamiliesFlightSegment' => '\\ArrayType\\ArrayOfAirFareFamiliesFlightSegment',
            'AirFareFamiliesFlightSegment' => '\\StructType\\AirFareFamiliesFlightSegment',
            'ArrayOfAirFareFamiliesFlightSegmentLeg' => '\\ArrayType\\ArrayOfAirFareFamiliesFlightSegmentLeg',
            'AirFareFamiliesFlightSegmentLeg' => '\\StructType\\AirFareFamiliesFlightSegmentLeg',
            'AirFareFamiliesPrice' => '\\StructType\\AirFareFamiliesPrice',
            'AirBookingCreate' => '\\StructType\\AirBookingCreate',
            'AirBookingRQ' => '\\StructType\\AirBookingRQ',
            'ArrayOfAirTraveler' => '\\ArrayType\\ArrayOfAirTraveler',
            'AirTraveler' => '\\StructType\\AirTraveler',
            'AirTravelerTSAData' => '\\StructType\\AirTravelerTSAData',
            'ArrayOfAirTravelerFlightSegmentLeg' => '\\ArrayType\\ArrayOfAirTravelerFlightSegmentLeg',
            'AirTravelerFlightSegmentLeg' => '\\StructType\\AirTravelerFlightSegmentLeg',
            'ArrayOfAirTravelerAncillary' => '\\ArrayType\\ArrayOfAirTravelerAncillary',
            'AirTravelerAncillary' => '\\StructType\\AirTravelerAncillary',
            'ArrayOfAirBookingBaggageLowCostTf' => '\\ArrayType\\ArrayOfAirBookingBaggageLowCostTf',
            'AirBookingBaggageLowCostTf' => '\\StructType\\AirBookingBaggageLowCostTf',
            'ArrayOfAirBookingBaggageNDC' => '\\ArrayType\\ArrayOfAirBookingBaggageNDC',
            'AirBookingBaggageNDC' => '\\StructType\\AirBookingBaggageNDC',
            'AirCreditCard' => '\\StructType\\AirCreditCard',
            'AirBookingCreateResponse' => '\\StructType\\AirBookingCreateResponse',
            'AirBookingRS' => '\\StructType\\AirBookingRS',
            'AirBooking' => '\\StructType\\AirBooking',
            'ArrayOfAirBookingNote' => '\\ArrayType\\ArrayOfAirBookingNote',
            'AirBookingNote' => '\\StructType\\AirBookingNote',
            'ArrayOfAirBookingFlightSegment' => '\\ArrayType\\ArrayOfAirBookingFlightSegment',
            'AirBookingFlightSegment' => '\\StructType\\AirBookingFlightSegment',
            'ArrayOfAirBookingFlightSegmentLeg' => '\\ArrayType\\ArrayOfAirBookingFlightSegmentLeg',
            'AirBookingFlightSegmentLeg' => '\\StructType\\AirBookingFlightSegmentLeg',
            'AirBookingAllowedBaggage' => '\\StructType\\AirBookingAllowedBaggage',
            'ArrayOfAirBookingFare' => '\\ArrayType\\ArrayOfAirBookingFare',
            'AirBookingFare' => '\\StructType\\AirBookingFare',
            'ArrayOfAirFlightTicket' => '\\ArrayType\\ArrayOfAirFlightTicket',
            'AirFlightTicket' => '\\StructType\\AirFlightTicket',
            'ArrayOfAirBookingFareFamilies' => '\\ArrayType\\ArrayOfAirBookingFareFamilies',
            'AirBookingFareFamilies' => '\\StructType\\AirBookingFareFamilies',
            'AirBookingEdit' => '\\StructType\\AirBookingEdit',
            'AirBookingEditResponse' => '\\StructType\\AirBookingEditResponse',
            'AirBookingCancel' => '\\StructType\\AirBookingCancel',
            'AirBookingCancelResponse' => '\\StructType\\AirBookingCancelResponse',
            'AirBookingMarkToTicketing' => '\\StructType\\AirBookingMarkToTicketing',
            'AirBookingMarkToTicketingRQ' => '\\StructType\\AirBookingMarkToTicketingRQ',
            'AirBookingMarkToTicketingResponse' => '\\StructType\\AirBookingMarkToTicketingResponse',
            'AirBookingTicketing' => '\\StructType\\AirBookingTicketing',
            'AirBookingTicketingRQ' => '\\StructType\\AirBookingTicketingRQ',
            'AirBookingTicketingResponse' => '\\StructType\\AirBookingTicketingResponse',
            'AirBookingTicketingRS' => '\\StructType\\AirBookingTicketingRS',
            'AirBookingInsurance' => '\\StructType\\AirBookingInsurance',
            'AirInsurancePolicy' => '\\StructType\\AirInsurancePolicy',
            'AirBookingCancelTickets' => '\\StructType\\AirBookingCancelTickets',
            'AirBookingCancelTicketsResponse' => '\\StructType\\AirBookingCancelTicketsResponse',
            'AirBookingSearch' => '\\StructType\\AirBookingSearch',
            'AirBookingSearchRQ' => '\\StructType\\AirBookingSearchRQ',
            'AirBookingSearchResponse' => '\\StructType\\AirBookingSearchResponse',
            'AirBookingSearchRS' => '\\StructType\\AirBookingSearchRS',
            'ArrayOfAirBookingSearchItem' => '\\ArrayType\\ArrayOfAirBookingSearchItem',
            'AirBookingSearchItem' => '\\StructType\\AirBookingSearchItem',
            'AirBookingGetPaxFares' => '\\StructType\\AirBookingGetPaxFares',
            'AirBookingGetPaxFaresResponse' => '\\StructType\\AirBookingGetPaxFaresResponse',
            'AirBookingPaxFaresRS' => '\\StructType\\AirBookingPaxFaresRS',
            'ArrayOfAirBookingPaxFare' => '\\ArrayType\\ArrayOfAirBookingPaxFare',
            'AirBookingPaxFare' => '\\StructType\\AirBookingPaxFare',
            'AirBookingChangePaxFares' => '\\StructType\\AirBookingChangePaxFares',
            'AirBookingChangePaxFaresResponse' => '\\StructType\\AirBookingChangePaxFaresResponse',
            'AirBookingGetRateNotes' => '\\StructType\\AirBookingGetRateNotes',
            'AirBookingGetRateNotesResponse' => '\\StructType\\AirBookingGetRateNotesResponse',
            'AirBookingUpdateTravelerTSAData' => '\\StructType\\AirBookingUpdateTravelerTSAData',
            'AirBookingUpdateTravelerTSADataRQ' => '\\StructType\\AirBookingUpdateTravelerTSADataRQ',
            'AirBookingUpdateTravelerTSADataResponse' => '\\StructType\\AirBookingUpdateTravelerTSADataResponse',
            'AirBookingUpdateTravelerTSADataRS' => '\\StructType\\AirBookingUpdateTravelerTSADataRS',
            'AirBookingImport' => '\\StructType\\AirBookingImport',
            'AirBookingImportRQ' => '\\StructType\\AirBookingImportRQ',
            'AirBookingImportResponse' => '\\StructType\\AirBookingImportResponse',
            'AirBookingCheckFeeCreditCardLowCost' => '\\StructType\\AirBookingCheckFeeCreditCardLowCost',
            'AirBookingCheckFeeCreditCardLowCostResponse' => '\\StructType\\AirBookingCheckFeeCreditCardLowCostResponse',
            'AirBookingPreCheckLowCostTf' => '\\StructType\\AirBookingPreCheckLowCostTf',
            'AirBookingPreCheckTfLowCostRQ' => '\\StructType\\AirBookingPreCheckTfLowCostRQ',
            'AirBookingPreCheckLowCostTfResponse' => '\\StructType\\AirBookingPreCheckLowCostTfResponse',
            'AirBookingPreCheckTfLowCostRS' => '\\StructType\\AirBookingPreCheckTfLowCostRS',
            'AirBookingCheckFeeLowCostTf' => '\\StructType\\AirBookingCheckFeeLowCostTf',
            'AirBookingCheckFeeLowCostTfResponse' => '\\StructType\\AirBookingCheckFeeLowCostTfResponse',
            'AirBookingTicketingLowCostTf' => '\\StructType\\AirBookingTicketingLowCostTf',
            'AirBookingTicketingLowCostTfResponse' => '\\StructType\\AirBookingTicketingLowCostTfResponse',
            'AirBookingPreCheckNDC' => '\\StructType\\AirBookingPreCheckNDC',
            'AirBookingPreCheckNDCRQ' => '\\StructType\\AirBookingPreCheckNDCRQ',
            'AirBookingPreCheckNDCResponse' => '\\StructType\\AirBookingPreCheckNDCResponse',
            'AirBookingPreCheckNDCRS' => '\\StructType\\AirBookingPreCheckNDCRS',
            'AgencyCardsList' => '\\StructType\\AgencyCardsList',
            'AgencyCardsListResponse' => '\\StructType\\AgencyCardsListResponse',
            'AgencyCardsListRS' => '\\StructType\\AgencyCardsListRS',
            'ArrayOfAgencyCard' => '\\ArrayType\\ArrayOfAgencyCard',
            'AgencyCard' => '\\StructType\\AgencyCard',
            'AirBookingTicketingLowCost' => '\\StructType\\AirBookingTicketingLowCost',
            'AirBookingTicketingLowCostResponse' => '\\StructType\\AirBookingTicketingLowCostResponse',
            'AirAvailLowCostBaggagePrice' => '\\StructType\\AirAvailLowCostBaggagePrice',
            'AirAvailLowCostBaggagePriceRQ' => '\\StructType\\AirAvailLowCostBaggagePriceRQ',
            'AirAvailLowCostBaggagePriceResponse' => '\\StructType\\AirAvailLowCostBaggagePriceResponse',
            'AirAvailLowCostBaggagePriceRS' => '\\StructType\\AirAvailLowCostBaggagePriceRS',
            'ArrayOfAirAvailBaggagePrice' => '\\ArrayType\\ArrayOfAirAvailBaggagePrice',
            'AirAvailBaggagePrice' => '\\StructType\\AirAvailBaggagePrice',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'AirAddress' => '\\StructType\\AirAddress',
            'AirBillingInformation' => '\\StructType\\AirBillingInformation',
        );
    }
}
