<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for AirTravelerDocumentTypes EnumType
 * Meta information extracted from the WSDL
 * - documentation: Enumeración con los tipos de documentos de los pasajeros. Es obligatorio informar el tipo de documento a la hora de realizar la reserva
 * - nillable: true
 * - type: tns:AirTravelerDocumentTypes
 * @subpackage Enumerations
 */
class AirTravelerDocumentTypes extends AbstractStructEnumBase
{
    /**
     * Constant for value 'DNI'
     * Meta information extracted from the WSDL
     * - documentation: Documento Nacional de Identidad
     * @return string 'DNI'
     */
    const VALUE_DNI = 'DNI';
    /**
     * Constant for value 'NIE'
     * Meta information extracted from the WSDL
     * - documentation: Tarjeta de Residente
     * @return string 'NIE'
     */
    const VALUE_NIE = 'NIE';
    /**
     * Constant for value 'PAS'
     * Meta information extracted from the WSDL
     * - documentation: Pasaporte
     * @return string 'PAS'
     */
    const VALUE_PAS = 'PAS';
    /**
     * Return allowed values
     * @uses self::VALUE_DNI
     * @uses self::VALUE_NIE
     * @uses self::VALUE_PAS
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_DNI,
            self::VALUE_NIE,
            self::VALUE_PAS,
        );
    }
}
