<?php

namespace EnumType;

use \WsdlToPhp\PackageBase\AbstractStructEnumBase;

/**
 * This class stands for SortOrder EnumType
 * Meta information extracted from the WSDL
 * - documentation: Enumeración para indicar la dirección del orden de un listado
 * - nillable: true
 * - type: tns:SortOrder
 * @subpackage Enumerations
 */
class SortOrder extends AbstractStructEnumBase
{
    /**
     * Constant for value 'None'
     * Meta information extracted from the WSDL
     * - documentation: No establecida
     * @return string 'None'
     */
    const VALUE_NONE = 'None';
    /**
     * Constant for value 'Asc'
     * Meta information extracted from the WSDL
     * - documentation: Ascendente
     * @return string 'Asc'
     */
    const VALUE_ASC = 'Asc';
    /**
     * Constant for value 'Desc'
     * Meta information extracted from the WSDL
     * - documentation: Descendente
     * @return string 'Desc'
     */
    const VALUE_DESC = 'Desc';
    /**
     * Return allowed values
     * @uses self::VALUE_NONE
     * @uses self::VALUE_ASC
     * @uses self::VALUE_DESC
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_NONE,
            self::VALUE_ASC,
            self::VALUE_DESC,
        );
    }
}
