<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AirBookingTicketing StructType
 * @subpackage Structs
 */
class AirBookingTicketing extends AbstractStructBase
{
    /**
     * The credentials
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AuthenticationCredentials
     */
    public $credentials;
    /**
     * The airBookingTicketingRQ
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirBookingTicketingRQ
     */
    public $airBookingTicketingRQ;
    /**
     * Constructor method for AirBookingTicketing
     * @uses AirBookingTicketing::setCredentials()
     * @uses AirBookingTicketing::setAirBookingTicketingRQ()
     * @param \StructType\AuthenticationCredentials $credentials
     * @param \StructType\AirBookingTicketingRQ $airBookingTicketingRQ
     */
    public function __construct(\StructType\AuthenticationCredentials $credentials = null, \StructType\AirBookingTicketingRQ $airBookingTicketingRQ = null)
    {
        $this
            ->setCredentials($credentials)
            ->setAirBookingTicketingRQ($airBookingTicketingRQ);
    }
    /**
     * Get credentials value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AuthenticationCredentials|null
     */
    public function getCredentials()
    {
        return isset($this->credentials) ? $this->credentials : null;
    }
    /**
     * Set credentials value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\AuthenticationCredentials $credentials
     * @return \StructType\AirBookingTicketing
     */
    public function setCredentials(\StructType\AuthenticationCredentials $credentials = null)
    {
        if (is_null($credentials) || (is_array($credentials) && empty($credentials))) {
            unset($this->credentials);
        } else {
            $this->credentials = $credentials;
        }
        return $this;
    }
    /**
     * Get airBookingTicketingRQ value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirBookingTicketingRQ|null
     */
    public function getAirBookingTicketingRQ()
    {
        return isset($this->airBookingTicketingRQ) ? $this->airBookingTicketingRQ : null;
    }
    /**
     * Set airBookingTicketingRQ value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\AirBookingTicketingRQ $airBookingTicketingRQ
     * @return \StructType\AirBookingTicketing
     */
    public function setAirBookingTicketingRQ(\StructType\AirBookingTicketingRQ $airBookingTicketingRQ = null)
    {
        if (is_null($airBookingTicketingRQ) || (is_array($airBookingTicketingRQ) && empty($airBookingTicketingRQ))) {
            unset($this->airBookingTicketingRQ);
        } else {
            $this->airBookingTicketingRQ = $airBookingTicketingRQ;
        }
        return $this;
    }
}
