<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AirMunicipalCodeList StructType
 * @subpackage Structs
 */
class AirMunicipalCodeList extends AbstractStructBase
{
    /**
     * The credentials
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AuthenticationCredentials
     */
    public $credentials;
    /**
     * The lstIata
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfstring
     */
    public $lstIata;
    /**
     * Constructor method for AirMunicipalCodeList
     * @uses AirMunicipalCodeList::setCredentials()
     * @uses AirMunicipalCodeList::setLstIata()
     * @param \StructType\AuthenticationCredentials $credentials
     * @param \ArrayType\ArrayOfstring $lstIata
     */
    public function __construct(\StructType\AuthenticationCredentials $credentials = null, \ArrayType\ArrayOfstring $lstIata = null)
    {
        $this
            ->setCredentials($credentials)
            ->setLstIata($lstIata);
    }
    /**
     * Get credentials value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AuthenticationCredentials|null
     */
    public function getCredentials()
    {
        return isset($this->credentials) ? $this->credentials : null;
    }
    /**
     * Set credentials value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\AuthenticationCredentials $credentials
     * @return \StructType\AirMunicipalCodeList
     */
    public function setCredentials(\StructType\AuthenticationCredentials $credentials = null)
    {
        if (is_null($credentials) || (is_array($credentials) && empty($credentials))) {
            unset($this->credentials);
        } else {
            $this->credentials = $credentials;
        }
        return $this;
    }
    /**
     * Get lstIata value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfstring|null
     */
    public function getLstIata()
    {
        return isset($this->lstIata) ? $this->lstIata : null;
    }
    /**
     * Set lstIata value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfstring $lstIata
     * @return \StructType\AirMunicipalCodeList
     */
    public function setLstIata(\ArrayType\ArrayOfstring $lstIata = null)
    {
        if (is_null($lstIata) || (is_array($lstIata) && empty($lstIata))) {
            unset($this->lstIata);
        } else {
            $this->lstIata = $lstIata;
        }
        return $this;
    }
}
